/*****************************************************************************
* FILE NAME:    EtherCAT_RSI.c - CvOW[
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <rt.h>

#include "EtherCAT_RSI.h"

// O[oϐ
RTHANDLE			hRootProcess;
DWORD				dwKtickInUsecs;
INIT_STRUCT			gInit;

/*****************************************************************************
* FUNCTION:     main
*
* DESCRIPTION:
*  ̓CvOW[ł
*  LAׂẴXbhAׂẴIuWFNg𐶐܂
*  main֐I܂ł̊ԃvZXƂđ݂AIɂׂ̂Ă͍폜܂
\*****************************************************************************/
void				main(int argc, char* argv[])
{
	SYSINFO			sysinfo;
	EVENTINFO		eiEventInfo;
#ifdef _DEBUG
	fprintf(stderr, "EtherCAT_RSI started\n");
#endif

	// [gvZX擾is܂j
	hRootProcess	= GetRtThreadHandles(ROOT_PROCESS);

	// W[\̂NA܂
	memset(&gInit, 0, sizeof(gInit));
	gInit.state		= BEFORE_INIT;

	// ჌xeBbNli}CNbj擾܂
	if (!CopyRtSystemInfo(&sysinfo))
		Fail("Cannot copy system info");
	dwKtickInUsecs	= 10000 / sysinfo.KernelTickRatio;
	if (dwKtickInUsecs == 0)
		Fail("Invalid low level tick length");

	// vZXővCIeB𒲐܂(s͖)
	// TODO adjust 2Ԗڂ̃p[^𐔒lIɏ邱Ƃł荂vCIeBXbhe܂
	SetRtProcessMaxPriority(NULL_RTHANDLE, 150);

	// CXbh(̊֐)̃nh擾܂
	gInit.hMain		= GetRtThreadHandles(THIS_THREAD);
	gInit.state		= INIT_BUSY;

	// XbhJ^O݂܂As͖܂
	Catalog(NULL_RTHANDLE, gInit.hMain, "TMain");

	// [gvZXɖ{vZXJ^O܂
	if (!Catalog(hRootProcess, GetRtThreadHandles(THIS_PROCESS), "EtherCAT_RSI"))
		Fail("Cannot catalog process name");
	gInit.bCataloged = TRUE;

	// |[OXbh𐶐܂
	if (BAD_RTHANDLE == CreateRtThread(170, (LPPROC)Poll1, 4096, 0))
		Fail("Cannot create poll thread Poll1");

	// Ƃ܂
	gInit.state		= INIT_DONE;
#ifdef _DEBUG
	fprintf(stderr, "EtherCAT_RSI finished initialization\n");
#endif

	// Cxgҋ@܂
	while (RtNotifyEvent(RT_SYSTEM_NOTIFICATIONS | RT_EXIT_NOTIFICATIONS,
		WAIT_FOREVER, &eiEventInfo))
	{
		switch(eiEventInfo.dwNotifyType)
		{
		case TERMINATE:
			// TODO: {vZX͏I܂
			// N[Abv܂
			Cleanup();  // ߂邱Ƃ͂܂

		case RT_CLIENT_DOWN:
			// TODO: NTzXgɂRTNCAg̃_EΉ
			break;

		case RT_CLIENT_UP:
			// TODO: NTzXgɂRTNCAgAΉ
			break;

		case NT_HOST_UP:
			// TODO: RTNCAgɂNTzXg̕AΉ
			break;

		case NT_BLUESCREEN:
			// TODO: NT̃u[XN[oΉ
			break;

		case KERNEL_STOPPING:
			// TODO: INtimeJ[lT[rX~Ή
			break;

		case NT_HOST_HIBERNATE:
			// TODO: WindowszXg̋x~ԈڍsΉ
			break;

		case NT_HOST_STANDBY:
			// TODO: WindowszXg̃X^oCԈڍsΉ
			break;
		}
	}
	Fail("Notify failed");
}
